module jp.ku6.bbs.logic.ThreadLogic;

import jp.ku6.firebird.core;
import jp.ku6.firebird.extension;
import jp.ku6.bbs.model.Thread;
import jp.ku6.bbs.dao.ThreadDao;

/++
 + スレッド管理クラス
 +/
class ThreadLogic
{
	/++
	 + コンストラクタ
	 +
	 + Params:
	 +  connectionPool = コネクションプール
	 +/
	this(ConnectionPool connectionPool)
	{
		connectionPool_ = connectionPool;
		transaction_ = new Transaction(null);
		threadDao_ = new ThreadDao(transaction_);
	}

	/++
	 + スレッド一覧情報を取得
	 +
	 + Returns:
	 +  スレッド一覧情報
	 +/
	Thread[] selectForListView()
	{
		// コネクションの取得と返却処理
		transaction_.connection = connectionPool_.lend(3);
		scope(exit)
		{
			connectionPool_.collect(transaction_.connection);
			transaction_.connection = null;
		}

		// トランザクションの開始と終了処理
		transaction_.begin();
		scope(failure) transaction_.rollback();
		scope(success) transaction_.commit();

		// データの取得
		return threadDao_.selectForListView();
	}

protected:

	// コネクションプール
	ConnectionPool connectionPool_;

	// トランザクション
	Transaction transaction_;

	// スレッドDAO
	ThreadDao threadDao_;
}